﻿/*
	"Duplicator"	Assembled by: David Torno (note that I said assembled and NOT created by)	:)
	
	This script was the result of a test. I was trying to understand how to build AE dockable scripts.
	While this is NOT the only way to create them, this turned out to be a more understandable method
	for my own brain. I wanted to start with a simple task for the test of building buttons and a UI.
	I chose Lloyd Alvarez's duplicate layer script that he taught to an audience at a Feb. 09 AENY presentation.
	http://www.vimeo.com/3031889
	
	This simple script was a good place for me to start building a UI. Along the way of building
	the UI for Lloyd's script I gathered various code information from other scripts created by
	Lloyd Alvarez, Jeff Almasol, Ian Haigh and got direct help from Paul Tuersley.
	
	I do not claim this script as my own, but felt it a useful one to share just in case it was not
	out there already. Plus I also felt that maybe it would also aid those who like myself were
	trying to get a handle on how to build UI for AE scripts.  I added a bunch of comments within the
	script to explain as best I could what each line of code does.
	
*/

{
function Dup(thisObj) {
	function Dup_buildUI(thisObj) {//legend...........................('Window type', 'Name of palette', [left edge, top edge, right edge, bottom edge];
		var myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Duplicator", [100, 100, 300, 300]);

		//Jeff Almasol's solution to fix text color
		var winGfx = myPanel.graphics;
		var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);

		//legend....................('button type', [left edge, top edge, right edge, bottom edge], 'button name');
		//"Qty:" text
		myPanel.butOne = myPanel.add("staticText", [10, 10, 40, 30], "Qty:");	//adds static text to panel

		//legend....................('button type', [left edge, top edge, right edge, bottom edge], 'button name');
		//Input box
		myPanel.butTwo = myPanel.add("editText", [45, 10, 100, 30], "10");	//adds edit text box to panel
		myPanel.butTwo.graphics.foregroundColor = darkColorBrush;   //Keeps text black at all times

		//"Do It!" button
		myPanel.butThree = myPanel.add("button", [10, 40, 70, 60], "Dup It!");	//adds a button to panel
		myPanel.butThree.onClick = dupIt;   //launch "dupIt" function when button is clicked

		return myPanel;	//ends the addition of interface additions like buttons, boxes, sliders, etc...
	}



	function dupIt() {	//starts "dupIt" function of "butThree" button

		var myComp = app.project.activeItem;	//Create variable to house active composition

		if(myComp instanceof CompItem) {	//Checks to see if selected comp actually is a comp

			app.beginUndoGroup("Dup It!");	//starts the undo group

			var counter = 0;	//variable to hold static value of 0
			var numCopies = parseInt(dupItPal.butTwo.text);	//variable to hold value of the butTwo user entered value

			//Selected layers loop
			var myLayers = myComp.selectedLayers;
			for (var i = 0; i < myLayers.length; i++) {

			var myLayer = myLayers[i];	//variable to hold result of loop
			var selLayers = myLayer;	//reassigning the variable name

			while(counter < numCopies){	//whilw loop that duplicates selected layer if the total layers is still below user entered value
				selLayers.duplicate();
				counter++;	//Incriments the counter each time a duplicate is created
				}
			}
			app.endUndoGroup();	//ends the undo group
		}
	}

	var dupItPal = Dup_buildUI(thisObj);	//variable to hold the Panel object

	if ((dupItPal != null) && (dupItPal instanceof Window)) {	//checks if panel is a window
		dupItPal.center();
		dupItPal.show();	//show a window instead
		}
	}

	Dup(this);	//show the dockable Panel
}